#ifndef __WHYW_FRAME_H__
#define __WHYW_FRAME_H__

/******************************************************************************
 * Include files
 ******************************************************************************/
#include "sys_config.h"
#if PRODUCT_WHYW
#include "UWater_frame_app.h"
#include "UWater_rtcc_driver.h"
/* C binding of definitions if building with C++ compiler */
#ifdef __cplusplus
extern "C"
{
#endif

/*******************************EEPROM洢ַ****************************/
#define STORE_DATA_SIZE_CIRCLE             4  //ݵ
#define STORE_DATA_COUNT_CIRCLE          240
#define EEP_DATA_LEN_CIRCLE           (STORE_DATA_SIZE_CIRCLE*STORE_DATA_COUNT_CIRCLE)//1200//ݴ洢ռ

#define EEP_ADDR_WHYW_STORE_CIRCLE    FRAME_SHENYANG_STORE_ADD //0x7300~0x7C00  ݴ洢ַ
#define EEP_ADDR_WHYW_CIRCLE_INDEX_W  (EEP_ADDR_WHYW_STORE_CIRCLE+EEP_DATA_LEN_CIRCLE)//ݴ洢ָ
#define EEP_ADDR_WHYW_CIRCLE_INDEX_R  (EEP_ADDR_WHYW_CIRCLE_INDEX_W+2)//ݶȡָ
#define EEP_ADDR_WHYW_LAST_RTCC  	  (EEP_ADDR_WHYW_CIRCLE_INDEX_R+2)//һ¼ʱ7ֽ
//òصĴ洢
#define EEP_ADDR_WHYW_NB_ONLINE_KEEP   (EEP_ADDR_WHYW_LAST_RTCC+7) //ʱʱ 1ֽ
#define EEP_ADDR_WHYW_STORE_INTERVAL   (EEP_ADDR_WHYW_NB_ONLINE_KEEP+1)//ݲɼ¼ʱ 1ֽ
#define EEP_ADDR_WHYW_BATTERY_PRA      (EEP_ADDR_WHYW_STORE_INTERVAL+1)//صѹز 4ֽ
#define EEP_ADDR_WHYW_UPLOAD_SUCCESS   (EEP_ADDR_WHYW_BATTERY_PRA+4)//ϱܴ
#define EEP_ADDR_WHYW_UPLOAD_FAIL      (EEP_ADDR_WHYW_UPLOAD_SUCCESS+4)//ϱɹܴ

#define UPLOAD_CIRCLE_MAX_COUNT  48 //֡48¼:48*4=192
#define UPLOAD_CIRCLE_MAX_LEN    (STORE_DATA_SIZE_CIRCLE*UPLOAD_CIRCLE_MAX_COUNT)//ֽ֡

#define EE_PRA_SIZE_WHYW  21//EE洢ֽ
typedef union 
{
	struct
	{
		UNION_2U8TOU16 u_circle_store_index_w;//ݴ洢λ
		UNION_2U8TOU16 u_circle_store_index_r;//ݶȡλ
		DateTime store_circle_rtcc_end;//һ¼ʱ7ֽ
		u8 ee_nb_online_keep_time;//ʱʱ 1ֽ
		u8 ee_nb_acq_interval;//ݲɼ¼ʱ 1ֽ ɼ30
		u8 ee_battery_pra[4];//صѹز
		UNION_2U8TOU16 ee_upload_count_success;//ϱɹܴ
		UNION_2U8TOU16 ee_upload_count_fail;//ϱʧܴ
	}Data;
	u8 data_buf[EE_PRA_SIZE_WHYW];
}WHYW_UNION_EE_STORE;
 /******************************Լز*********************************/
#define FRAME_HEAD_MARK            0x68       
#define FRAME_END_MARK             0x16       
#define UP_BUF_SIZE                 512

#define FRAME_LEN_MAX       UP_BUF_SIZE
#define FRAME_LEN_MIN       10

#define FRAME_GUIDE         0xFE       	//
#define FRAME_HEAD          0x68       	//֡ͷ
#define FRAME_TAIL          0x16       	//֡β

#define W_METTYPE                  			      0x10        //ˮ
#define LYBK_DATA_UP_NOW                          0x55
#define LYBK_OFFSET_DATA_UP                       0xFF
#define LYBK_DISCRETE_DATA_UP                     0x99


#define READ_CTRL_DOWN                      	0x01   //
#define READ_CTRL_UP                         	0x81   //
#define WRITE_CTRL_DOWN                      	0x04   //д
#define WRITE_CTRL_UP                       	0x84   //д

//дˮʱȴʱ
#define RW_ONLINE_TIME_D0          0x81   
#define RW_ONLINE_TIME_D1          0x11  

//дˮʵʱʱ
#define RW_METER_TIME_D0           0xA0          
#define RW_METER_TIME_D1           0x15  

//дˮԶϴݵʱ
#define RW_UPLOAD_TIME_ID0         0x81        
#define RW_UPLOAD_TIME_ID1         0x04

//дˮݲɼʱ
#define RW_INTERVAL_TIME_ID0       0x81            
#define RW_INTERVAL_TIME_ID1       0x05 

//дȡصѹز
#define RW_BATTERY_D0              0x81            
#define RW_BATTERY_D1              0x09            

//дˮ NB 
#define RW_NB_PARA_D0              0x81            
#define RW_NB_PARA_D1              0x10

  
//ǰϢݱʶD0
#define UPLOAD_DATA_D0               0x90          
#define UPLOAD_DATA_D1               0x20           
//////////////////////////////////////////////////////////////////////////////////////////////////////////
typedef union  //ǿתΪ
{
    u32   gp22_u32;
    float gp22_float;
    u8 buf[4];
}U32_To_Float;

typedef struct //űյıȽҪ
{	
	u8 head_site;
	u8 frame_ctrl; 		//п
	u8 ack_ctrl;        //п
	u8 mark_DI0;   		//ݱʶDI0
	u8 mark_DI1;    	//ݱʶDI1
	u8 serial_num; 	//к
	mtype16_ len;        	//
	u16 chkval;     	//У
	u8 frame_sta;   	//Լ״̬
} STRUCT_FRAME_WHYW;

typedef struct
{
	u16 send_len;
	u8	send_sum_cs;        //У
	u8 send_buf[UP_BUF_SIZE];
}OTHER_FRAME_UP_SEND_PARA_;


typedef enum{	
	WHYW_STATE_S0 = 0,
	WHYW_STATE_S1,
	WHYW_STATE_S2,
	WHYW_STATE_S3,
	WHYW_STATE_S4,
	WHYW_STATE_S5,
	WHYW_STATE_S6,
	WHYW_STATE_S7,
	WHYW_STATE_S8,
	WHYW_STATE_S9,
	WHYW_STATE_S10,
	WHYW_STATE_S11,
	WHYW_STATE_S12,
	WHYW_STATE_S13,
	WHYW_STATE_S20,
	WHYW_STATE_S21,
	WHYW_STATE_S22,
	WHYW_STATE_S30,
	WHYW_STATE_S31,
	WHYW_STATE_S32,
}TYP_STATE_WHYW;


u8 crack_frame_WHYW(u16 frame_lenth, u8 *frame_buffer);
u8 up_deal_code_WHYW(void);
void Frame_ack_WHYW(u8* p_send_buf, u16* p_send_len);
void Frame_ResetDealState_WHYW(void);

void GetUploadDataResetState_WHYW(void);
u8 GetUploadDataCheckIdle_WHYW(void);
u8 GetUploadDataCheckTask_WHYW(void);
void GetUploadDataMachine_WHYW(u8 data_step, u8* p_send_buf, u16* p_send_len);

/****************************Լݴ洢*****************************/
void DataStoreInit(void);
void DataStoreMachine(void);
u8 DataStoreIfIdle(void);
/************************ѡ\ʱȴʱ********************/
#define MAIN_CONNECT_TYPE      NBIOT_CONNECT_UDP1
#define MAIN_SEND_TYPE         SEND_TYPE_UDP1
#define SLAVE_CONNECT_TYPE     NBIOT_CONNECT_UDP2
#define SLAVE_SEND_TYPE        SEND_TYPE_UDP2

#define COAP_UPLOAD_WAIT_ACK_TIME  150   //ϱ15룬ϱ5
#define UDP_UPLOAD_WAIT_ACK_TIME   50 
#define NB_ONLINE_KEEP_TIME  50

#ifdef __cplusplus
}
#endif 

#endif

#endif /* __LYBK_FRAME_H__ */
/******************************************************************************
 * EOF (not truncated)
 ******************************************************************************/










