/************************************************************************************
 * @Copyright (c)    :(C)2021, Qindao ieslab Co., Ltd
 * @FileName   	     :hdsc_nb_uart_driver.c
 * @Author           :QDIES PLATFORM TEAM
 * @Version          :V1.1
 * @Date             :2021-07
 * @Description      :
 ************************************************************************************/
#include "sys_config.h"
#ifdef MODULE_BLE_USED

#ifdef	__cplusplus
extern "C"
{
#endif

#include "UWater_uart_driver.h"
#include "ble14531_uart_driver.h"
#include "ble14531_driver.h"
#include "UWater_rtcc_driver.h"
#include "sys_processor.h"
#include "UWater_DebugPrint.h"

///********************************************************************/
BLE_UART_COMM BLE_Uart_Comm;
u8 g_s_ble_rev_state;		//״̬״̬
u8 g_s_ble_revc_frame_state = BLE_S0;

volatile u8 v_g_ble_rcv_data = 0;
u8 s_ble_buf[BLE_AT_RCV_BUF_SIZE] = {0};
#if BLE_CENTRAL_SLAVE_MOD
BLE_SLAVE_INFO a_ble_scan_buf[BLE_AT_SCAN_MAC_TOTAL];
u8 g_ble_sacn_complete = FALSE;
u8 g_ble_temp_array[22];
u8 g_ble_check_index;
u8 g_ble_macindex;
u8 g_ble_scanindex;
#endif
u8 g_ble_rcvindex;
mtype16_ g_ble_uart_temp;
u8 g_ble_reset_flag = FALSE;
u8 s_g_buf[1];
///*****************************ڲ״̬***********************************/
void BLE_AT_OK_AND_ERROR_MACHINE(u8 data);
void BLE_AT_AT_MACHINE(u8 data);
void BLE_AT_QUERY_MACHINE(u8 data);
void BLE_AT_SCAN_MACHINE(u8 data);
void BLE_AT_BLE_RCV_FRAME_MACHINE(u8 data);

/***************************************************************************
 * @fun_name     static void UART_Receive_IT(Nbiot_UART_HandleTypeDef *huart)
 * @brief        ڽжϴ
 * @param[in]    None
 * @param[out]   None
 * @retval       None
 * @other        None
 ***************************************************************************/
void BleUartReceiveIT(void)
{
#if(BLE_LP_COM)
	v_g_ble_rcv_data = LPUart_ReceiveData(BLE_UART_REALCOM);
#else
	v_g_ble_rcv_data = Uart_ReceiveData(BLE_UART_COM);
#endif

	switch (BLE_Uart_Comm.send_style)
	{
		case BLE_cst_AT_NOMAL_RCV:
		{
			break;
		}

		case BLE_cst_AT_OK_ERROR:
		{
			BLE_AT_OK_AND_ERROR_MACHINE(v_g_ble_rcv_data); 	//״̬ǰһ
			break;
		}

		case BLE_cst_AT_AT:
		{
			BLE_AT_AT_MACHINE(v_g_ble_rcv_data); 		//״̬ǰһ
			break;
		}

		case BLE_cst_AT_QUERY:
		{
			BLE_AT_QUERY_MACHINE(v_g_ble_rcv_data); 	//״̬ǰһ
			break;
		}
#if BLE_CENTRAL_SLAVE_MOD
		case BLE_cst_AT_SCAN_RCV:						//չ㲥
		{
			BLE_AT_SCAN_MACHINE(v_g_ble_rcv_data);
		}
		break;
#endif			
		default:
		break;
	}
	BLE_AT_BLE_RCV_FRAME_MACHINE(v_g_ble_rcv_data);		//BLE͸
	s_g_buf[0] = v_g_ble_rcv_data;
    PrintNbData(s_g_buf,1);//ӡԴ
}


/***************************************************************************
 * @fun_name     void BleUartSend(u8 *buf, u16 len, u8 style)
 * @brief        
 * @param[in] 	 bufݵĵַ  lenͳ
                  styleͷʽATָšbleݣ
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
void BleUartSend(u8 *buf, u16 len, u8 style)
{
    static u8 send_msg_ble;
    if (len > 0)
    {
        UartSend(BLE_UART_COM, len, buf, &send_msg_ble);
        //״̬ʼ
        g_s_ble_rev_state = BLE_S0;
        BLE_Uart_Comm.rev_ack_flag = BLE_UART_ING;
        BLE_Uart_Comm.send_style = style;
    }
}

void BleUartChangeStyle(u8 style)
{
	g_s_ble_rev_state = BLE_S0;
	BLE_Uart_Comm.rev_ack_flag = BLE_UART_ING;
	BLE_Uart_Comm.send_style = style;
}

/***************************************************************************
* @fun_name		u8 BleUartChkStyle(void)
* @brief		ѯBLEڽģʽ
* @param[in]	None
* @param[out]	None
* @retval		ģʽӦӦָ
* @other		None
***************************************************************************/
u8 BleUartChkStyle(void)
{
	return BLE_Uart_Comm.send_style;
}

/***************************************************************************
* @fun_name		s8 BleCheckAtAck()
* @brief		ѯڷǷȷ
* @param[in]	None
* @param[out]	None
* @retval		BLE_UART_ING: BLE_UART_OKȷ֡ BLE_UART_ERROR֡
* @other		None
***************************************************************************/
s8 BleCheckAtAck(void)
{
    return BLE_Uart_Comm.rev_ack_flag;
}

/***************************************************************************
* @fun_name		u8 BleRcvAtData(u8 **p_data)
* @brief		ѯڷǷȷ
* @param[in]	None
* @param[out]	None
* @retval		BLE_UART_ING: BLE_UART_OKȷ֡ BLE_UART_ERROR֡
* @other		None
***************************************************************************/
u8 BleRcvAtData(u8 **p_data)
{
	*p_data = s_ble_buf;
    return g_ble_rcvindex;
}

/***************************************************************************
* @fun_name		void BLE_AT_OK_AND_ERROR_MACHINE(u8 data)
* @brief		ģ鷵ȷ״̬
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BLE_AT_OK_AND_ERROR_MACHINE(u8 data)
{
    switch (g_s_ble_rev_state)
    {
        case BLE_S0:
        {
            if(data == 'O')
            {
                g_s_ble_rev_state = BLE_S1;
            }            
        }
		break;

        case BLE_S1:
        {
            if(data == 'K')
            {
				g_s_ble_rev_state = BLE_S2;
            }
            else if(data == 'R')
            {
                BLE_Uart_Comm.rev_ack_flag = BLE_UART_ERROR;
				g_s_ble_rev_state = BLE_S0;
            }
			else
			{
				g_s_ble_rev_state = BLE_S0;
			}
        }
		break;
		
		case BLE_S2:
		{
			if(data == '+')
			{
				g_s_ble_rev_state = BLE_S3;
			}
			else if(data == '\n' || data == '\r')
			{
				BLE_Uart_Comm.rev_ack_flag = BLE_UART_OK;
				g_s_ble_rev_state = BLE_S0;
			}
			else
			{
				g_s_ble_rev_state = BLE_S0;
			}
		}
		break;
		
		case BLE_S3:
		{
			if(data == '=')
			{
				g_s_ble_rev_state = BLE_S4;
			}
			else if(data == '\n' || data == '\r')
			{
				BLE_Uart_Comm.rev_ack_flag = BLE_UART_OK;
				g_s_ble_rev_state = BLE_S0;
			}
		}
		break;
		
		case BLE_S4:
		{
			if(data == 'O')
			{
				g_s_ble_rev_state = BLE_S5;
			}
		}
		break;
		
		case BLE_S5:
		{
			if(data == 'K')
            {
				BLE_Uart_Comm.rev_ack_flag = BLE_UART_OK;
            }
            else if(data == 'R')
            {
                BLE_Uart_Comm.rev_ack_flag = BLE_UART_ERROR;
            }
			g_s_ble_rev_state = BLE_S0;
		}
		break;

        default:
			g_s_ble_rev_state = BLE_S0;
		break;
    }
}

/***************************************************************************
* @fun_name		void BLE_AT_AT_MACHINE(u8 data)
* @brief		鴮ںģ飬ATָ
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BLE_AT_AT_MACHINE(u8 data)
{
    switch (g_s_ble_rev_state)
    {
        case BLE_S0:
        {
            if (data == 'A')
            {
                g_s_ble_rev_state = BLE_S1;
            }
        }
        break;

        case BLE_S1:
        {
			g_s_ble_rev_state = (data == 'T' ? BLE_S2 : BLE_S0);
        }
        break;

        case BLE_S2:
        {
			BLE_Uart_Comm.rev_ack_flag = (data == '\n' ? BLE_UART_OK : BLE_UART_ERROR);
			g_s_ble_rev_state = BLE_S0;
        }
        break;

        default:
        {
            g_s_ble_rev_state = BLE_S0;
        }
        break;
    }
}

/***************************************************************************
* @fun_name		void BLE_AT_QUERY_MACHINE(u8 data)
* @brief		ѯģ״̬
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BLE_AT_QUERY_MACHINE(u8 data)
{
    switch (g_s_ble_rev_state)
    {
        case BLE_S0:
        {
            if(data == 'O')
            {
                g_s_ble_rev_state = BLE_S1;
            }            
        }
		break;

        case BLE_S1:
        {
			g_s_ble_rev_state = data == 'K' ? BLE_S2 : BLE_S0;
        }
		break;
		
		case BLE_S2:
        {
			g_s_ble_rev_state = data == '+' ? BLE_S3 : BLE_S0;
        }
		break;
		
		case BLE_S3:
        {
			if(data == '=')
			{
				memset(s_ble_buf, 0, sizeof(s_ble_buf));
				g_ble_rcvindex = 0;
				g_s_ble_rev_state = BLE_S4;
			}
        }
		break;
		
		case BLE_S4:
        {
			if(data == '\n')
			{
				BLE_Uart_Comm.rev_ack_flag = BLE_UART_OK;
				g_s_ble_rev_state = BLE_S0;
			}
			else
			{
				if(g_ble_rcvindex < BLE_AT_RCV_BUF_SIZE)
				{
					s_ble_buf[g_ble_rcvindex++] = data;
				}
				else
				{
					BLE_Uart_Comm.rev_ack_flag = BLE_UART_OK;
					g_s_ble_rev_state = BLE_S0;
				}
			}
        }
		break;

        default:
			g_s_ble_rev_state = BLE_S0;
		break;
    }
}

#if BLE_CENTRAL_SLAVE_MOD
/***************************************************************************
* @fun_name		void BLE_AT_SCAN_MACHINE(u8 data)
* @brief		ģɨ״̬
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
const u8 scAT_SCAN_END[] = "SCAN COMPLETE";
#define AT_CHECK_LEN_SCAN_END		(sizeof(scAT_SCAN_END) - 1)
void BLE_AT_SCAN_MACHINE(u8 data)
{
	switch(g_s_ble_rev_state)
	{
		case BLE_S0:
		{
			if(data == scAT_SCAN_END[g_ble_check_index])
			{
				if(++g_ble_check_index >= AT_CHECK_LEN_SCAN_END)	//жɨؼ
				{
					g_ble_check_index = 0;
					g_ble_sacn_complete = TRUE;						//ɨ
					BLE_Uart_Comm.rev_ack_flag = BLE_UART_OK;
				}
			}
			else
			{
				g_ble_check_index = 0;
			}
			if((data == 'M') && (0 == g_ble_check_index))
			{
				g_s_ble_rev_state = BLE_S1;
			}
			break;
		}
		case BLE_S1:
		{
			if(g_ble_scanindex >= BLE_AT_SCAN_MAC_TOTAL)
			{
				g_ble_scanindex = 0;
			}
			g_ble_macindex = 0;
			g_s_ble_rev_state = (data == 'A' ? BLE_S2 : BLE_S0);
			break;
		}
		
		case BLE_S2:
		{
			if(':' == data)
			{
				g_s_ble_rev_state = BLE_S3;
			}
		}
		break;
		
		case BLE_S3:		//ȡMACַ
		{
			g_ble_temp_array[g_ble_macindex++] = data;
			if(g_ble_macindex >= 12)
			{
				g_ble_macindex = 0;				
				format_ascii2hex(a_ble_scan_buf[g_ble_scanindex].mac,g_ble_temp_array,12);	//תΪ6ֽ
				//ڴ˴ݵõMACϢй
				
				g_s_ble_rev_state = BLE_S4;
			}
			break;
		}
		case BLE_S4:
		{
			g_s_ble_rev_state = (data == ',' ? BLE_S5 : BLE_S0);	
		}
		break;
		
		case BLE_S5:
		{
			g_s_ble_rev_state = (data == 'R' ? BLE_S6 : BLE_S0);
		}
		break;
		
		case BLE_S6:
		{
			g_ble_uart_temp.to_uint16 = 0;
			g_s_ble_rev_state = (data == ':' ? BLE_S7 : BLE_S6);
		}
		break;
		
		case BLE_S7:		//ȡRSSI
		{
			if((',' == data) || (0x0A == data) || (0x0D == data))	//سл","
			{
				g_ble_uart_temp.to_uint16 = (~g_ble_uart_temp.to_uint16) + 1;
				a_ble_scan_buf[g_ble_scanindex].rssi.to_uint16 = g_ble_uart_temp.to_uint16;
				g_s_ble_rev_state = BLE_S8;
			}
			else
			{
				if(data >= 0x30 && data <= 0x39)
				{
					g_ble_uart_temp.to_uint16 = g_ble_uart_temp.to_uint16 * 10;
					g_ble_uart_temp.to_uint16 += (data - 0x30);
				}
				if(g_ble_uart_temp.to_uint16 > 0xFF)	//һظRSSIķΧ0~-255
				{
					g_ble_uart_temp.to_uint16 = g_ble_uart_temp.to_uint16 % 0xFF;
					g_s_ble_rev_state = BLE_S8;
				}
			}
		}
		break;
		
		case BLE_S8:
		{
			g_s_ble_rev_state = (data == 'S' ? BLE_S9 : BLE_S0);		//ûй㲥ʱ½
		}
		break;
		
		case BLE_S9:
		{
			g_ble_macindex = 0;
			g_s_ble_rev_state = (data == ':' ? BLE_S10 : BLE_S9);
		}
		break;
		
		case BLE_S10:		//ȡ㲥
		{
			if(g_ble_macindex >= 11)
		   {
				g_ble_macindex = 0;
				g_ble_scanindex++;
				g_s_ble_rev_state = BLE_S0;
		   }
		   else
		   {
				a_ble_scan_buf[g_ble_scanindex].adv_data[g_ble_macindex++] = data;
		   }
		}
		break;

		default:
			g_s_ble_rev_state = BLE_S0;
		break;
	}
}
#endif
///***************************************************************************
//* @fun_name		void BLE_AT_BLE_RCV_FRAME_MACHINE(u8 data)
//* @brief		ģ͸
//* @param[in]	None
//* @param[out]	None
//* @retval		None
//* @other		None
//***************************************************************************/
void BLE_AT_BLE_RCV_FRAME_MACHINE(u8 data)
{
	switch(g_s_ble_revc_frame_state)
	{
		case BLE_S0:
		{
			if(0xFE == data || (0x68 == data))
			{
				BLE_Uart_Comm.ble_rcv_flag = 1;
				BLE_Uart_Comm.ble_rcv_len = 0;
				BLE_Uart_Comm.ble_rev_buf[BLE_Uart_Comm.ble_rcv_len++] = data;
				g_s_ble_revc_frame_state = BLE_S1;
			}
			else 
			{
				switch(data)
				{
					case 'R':
					{
						g_s_ble_revc_frame_state = BLE_S2;
						break;
					}
					case 'E':
					{
						g_s_ble_revc_frame_state = BLE_S3;
						break;
					}
				}
			}
		}
		break;
		
		case BLE_S1:
		{
			if(BLE_Uart_Comm.ble_rcv_len < BLE_UP_BUF_SIZE)
			{
				BLE_Uart_Comm.ble_rcv_flag = 1;
				BLE_Uart_Comm.ble_rev_buf[BLE_Uart_Comm.ble_rcv_len++] = data;
			}
			else
			{
				BLE_Uart_Comm.ble_rcv_len = 0;
				g_s_ble_revc_frame_state = BLE_S0;
			}
		}
		break;
		
		//BLERESETյESETĸַ
		case BLE_S2:	
		{
			g_s_ble_revc_frame_state = (data == 'E' ? BLE_S3 : BLE_S0);
		}
		break;
		
		case BLE_S3:	
		{
			g_s_ble_revc_frame_state = (data == 'S' ? BLE_S4 : BLE_S0);
		}
		break;
		
		case BLE_S4:	
		{
			g_s_ble_revc_frame_state = (data == 'E' ? BLE_S5 : BLE_S0);
		}
		break;
		
		case BLE_S5:	
		{
			g_s_ble_revc_frame_state = (data == 'T' ? BLE_S6 : BLE_S0);
		}
		break;
		
		case BLE_S6:
		{
			if('\n' == data)	
			{
				g_ble_reset_flag = TRUE;
			}
			g_s_ble_revc_frame_state = BLE_S0;
		}
		break;
	}
}


#if BLE_CENTRAL_SLAVE_MOD
/***************************************************************************
* @fun_name		void BleClrMacBuf(void)
* @brief		ɨݴŻ
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleClrMacBuf(void)
{
	memset(a_ble_scan_buf, 0, sizeof(a_ble_scan_buf));
	g_ble_scanindex = 0;
}

/***************************************************************************
* @fun_name		u8 BleGetScanDevInfo(BLE_SLAVE_INFO (*p_data)[])
* @brief		ȡɨ赽豸Ϣ
* @param[in]	None
* @param[out]	ɨ赽豸MACźϢ
* @retval		豸20ͷļж
* @other		None
***************************************************************************/
u8 BleGetScanDevInfo(BLE_SLAVE_INFO **p_data)
{
	*p_data = a_ble_scan_buf;
    return g_ble_scanindex;
}
/***************************************************************************
* @fun_name		u8 BleGetScanCompleteFlag(void)
* @brief		ȡɨɱ־
* @param[in]	None
* @param[out]	None
* @retval		ɨɱ־TRUEɣFALSEδ
* @other		None
***************************************************************************/
u8 BleGetScanCompleteFlag(void)
{
	return g_ble_sacn_complete;
}
/***************************************************************************
* @fun_name		void BleClrScanCompleteFlag(void)
* @brief		ɨɱ־ɨݴŻindex
* @param[in]	None
* @param[out]	None
* @retval		NONE
* @other		None
***************************************************************************/
void BleClrScanCompleteFlag(void)
{
	g_ble_sacn_complete = FALSE;
	g_ble_scanindex = 0;			//indexͬʱ
}
#endif

/***************************************************************************
* @fun_name		u8 BleRcvFrameDataFlag(void)
* @brief		յЧԼݵϢ
* @param[in]	None
* @param[out]	None
* @retval		NONE
* @other		None
***************************************************************************/
u8 BleRcvFrameDataFlag(void)
{
	return BLE_Uart_Comm.ble_rcv_flag;
}

/***************************************************************************
* @fun_name		void BleClrRcvFrameDataFlag(void)
* @brief		յЧԼݵϢ
* @param[in]	None
* @param[out]	None
* @retval		NONE
* @other		None
***************************************************************************/
void BleClrRcvFrameDataFlag(void)
{
	BLE_Uart_Comm.ble_rcv_flag = 0;
}

/******************************************************************************************
 * @fun_name    void BleGetUartRcvData(u8 **rev_data,u16 *data_len)
 * @brief       ȡBLEڽյ
 * @param[out] 	rev_data: ݻ
                data_lenݳ
 *****************************************************************************************/
void BleGetUartRcvData(u8 **rev_data,u16 *data_len)
{
    *rev_data = BLE_Uart_Comm.ble_rev_buf;
    *data_len = BLE_Uart_Comm.ble_rcv_len;
	
	BLE_Uart_Comm.ble_rcv_len = 0;
	g_s_ble_revc_frame_state = BLE_S0;
}

//ѯBLEǷ˸λ
u8 BleCheckIfResetFlag(void)
{
	return g_ble_reset_flag;
}
//BLEλ־
void BleClrIfResetFlag(void)
{
	g_ble_reset_flag = FALSE;
}
#endif
